Index: kernel/genarch/Makefile.inc
===================================================================
--- kernel/genarch/Makefile.inc	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ kernel/genarch/Makefile.inc	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -66,5 +66,4 @@
 	GENARCH_SOURCES += \
 		genarch/src/fb/font-8x16.c \
-		genarch/src/fb/logo-196x66.c \
 		genarch/src/fb/fb.c \
 		genarch/src/fb/bfb.c
Index: kernel/genarch/src/fb/fb.c
===================================================================
--- kernel/genarch/src/fb/fb.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ kernel/genarch/src/fb/fb.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -35,5 +35,4 @@
 
 #include <genarch/fb/font-8x16.h>
-#include <genarch/fb/logo-196x66.h>
 #include <genarch/fb/fb.h>
 #include <console/chardev.h>
@@ -53,6 +52,6 @@
 #include <byteorder.h>
 
-#define BG_COLOR     0x000080
-#define FG_COLOR     0xffff00
+#define BG_COLOR     0x001620
+#define FG_COLOR     0xf3cf65
 #define INV_COLOR    0xaaaaaa
 
@@ -93,6 +92,4 @@
 	unsigned int yres;
 	
-	unsigned int ylogo;
-	unsigned int ytrim;
 	unsigned int rowtrim;
 	
@@ -213,17 +210,4 @@
 }
 
-/** Hide logo and refresh screen
- *
- */
-static void logo_hide(fb_instance_t *instance)
-{
-	instance->ylogo = 0;
-	instance->ytrim = instance->yres;
-	instance->rowtrim = instance->rows;
-	
-	if ((!instance->parea.mapped) || (console_override))
-		fb_redraw_internal(instance);
-}
-
 /** Draw character at given position
  *
@@ -236,7 +220,4 @@
 	unsigned int yd;
 	
-	if (y >= instance->ytrim)
-		logo_hide(instance);
-	
 	if (!overlay)
 		instance->backbuf[BB_POS(instance, col, row)] = glyph;
@@ -244,5 +225,5 @@
 	if ((!instance->parea.mapped) || (console_override)) {
 		for (yd = 0; yd < FONT_SCANLINES; yd++)
-			memcpy(&instance->addr[FB_POS(instance, x, y + yd + instance->ylogo)],
+			memcpy(&instance->addr[FB_POS(instance, x, y + yd)],
 			    &instance->glyphs[GLYPH_POS(instance, glyph, yd)],
 			    instance->glyphscanline);
@@ -256,9 +237,4 @@
 static void screen_scroll(fb_instance_t *instance)
 {
-	if (instance->ylogo > 0) {
-		logo_hide(instance);
-		return;
-	}
-	
 	if ((!instance->parea.mapped) || (console_override)) {
 		unsigned int row;
@@ -412,22 +388,8 @@
 static void fb_redraw_internal(fb_instance_t *instance)
 {
-	if (instance->ylogo > 0) {
-		unsigned int y;
-		
-		for (y = 0; y < LOGO_HEIGHT; y++) {
-			unsigned int x;
-			
-			for (x = 0; x < instance->xres; x++)
-				instance->rgb_conv(&instance->addr[FB_POS(instance, x, y)],
-				    (x < LOGO_WIDTH) ?
-				    fb_logo[y * LOGO_WIDTH + x] :
-				    LOGO_COLOR);
-		}
-	}
-	
 	unsigned int row;
 	
 	for (row = 0; row < instance->rowtrim; row++) {
-		unsigned int y = instance->ylogo + ROW2Y(row);
+		unsigned int y = ROW2Y(row);
 		unsigned int yd;
 		
@@ -452,14 +414,13 @@
 		    (instance->xres - COL2X(instance->cols)) * instance->pixelbytes;
 		
-		for (y = instance->ylogo; y < instance->yres; y++)
+		for (y = 0; y < instance->yres; y++)
 			memcpy(&instance->addr[FB_POS(instance, COL2X(instance->cols), y)],
 			    instance->bgscan, size);
 	}
 	
-	if (ROW2Y(instance->rowtrim) + instance->ylogo < instance->yres) {
+	if (ROW2Y(instance->rowtrim) < instance->yres) {
 		unsigned int y;
 		
-		for (y = ROW2Y(instance->rowtrim) + instance->ylogo;
-		    y < instance->yres; y++)
+		for (y = ROW2Y(instance->rowtrim); y < instance->yres; y++)
 			memcpy(&instance->addr[FB_POS(instance, 0, y)],
 			    instance->bgscan, instance->bgscanbytes);
@@ -567,15 +528,5 @@
 	instance->rows = Y2ROW(instance->yres);
 	
-	if (instance->yres > LOGO_HEIGHT) {
-		instance->ylogo = LOGO_HEIGHT;
-		instance->rowtrim = instance->rows - Y2ROW(instance->ylogo);
-		if (instance->ylogo % FONT_SCANLINES > 0)
-			instance->rowtrim--;
-		instance->ytrim = ROW2Y(instance->rowtrim);
-	} else {
-		instance->ylogo = 0;
-		instance->ytrim = instance->yres;
-		instance->rowtrim = instance->rows;
-	}
+	instance->rowtrim = instance->rows;
 	
 	instance->glyphscanline = FONT_WIDTH * instance->pixelbytes;
Index: uspace/app/bdsh/cmds/modules/cat/cat.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cat/cat.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/bdsh/cmds/modules/cat/cat.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -117,21 +117,24 @@
 static void waitkey()
 {
-	kbd_event_t ev;
+	cons_event_t ev;
+	kbd_event_t *kev;
 	
 	while (true) {
-		if (!console_get_kbd_event(console, &ev)) {
+		if (!console_get_event(console, &ev)) {
 			return;
 		}
-		if (ev.type == KEY_PRESS) {
-			if (ev.key == KC_ESCAPE || ev.key == KC_Q) {
+		if (ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS) {
+			kev = &ev.ev.key;
+			
+			if (kev->key == KC_ESCAPE || kev->key == KC_Q) {
 				should_quit = true;
 				return;
 			}
-			if (ev.key == KC_C) {
+			if (kev->key == KC_C) {
 				paging_enabled = false;
 				return;
 			}
-			if (ev.key == KC_ENTER || ev.key == KC_SPACE ||
-			    ev.key == KC_PAGE_DOWN) {
+			if (kev->key == KC_ENTER || kev->key == KC_SPACE ||
+			    kev->key == KC_PAGE_DOWN) {
 				return;
 			}
Index: uspace/app/bdsh/cmds/modules/cp/cp.c
===================================================================
--- uspace/app/bdsh/cmds/modules/cp/cp.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/bdsh/cmds/modules/cp/cp.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -152,13 +152,13 @@
 
 	while (true) {
-		kbd_event_t ev;
+		cons_event_t ev;
 		console_flush(con);
-		console_get_kbd_event(con, &ev);
-		if ((ev.type != KEY_PRESS)
-		    || (ev.mods & (KM_CTRL | KM_ALT)) != 0) {
+		console_get_event(con, &ev);
+		if (ev.type != CEV_KEY || ev.ev.key.type != KEY_PRESS ||
+		    (ev.ev.key.mods & (KM_CTRL | KM_ALT)) != 0) {
 			continue;
 		}
 
-		switch(ev.key) {
+		switch(ev.ev.key.key) {
 		case KC_Y:
 			printf("y\n");
Index: uspace/app/edit/edit.c
===================================================================
--- uspace/app/edit/edit.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/edit/edit.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -80,4 +80,7 @@
 	tag_t sel_start;
 
+	/** Active keyboard modifiers */
+	keymod_t keymod;
+
 	/** 
 	 * Ideal column where the caret should try to get. This is used
@@ -119,4 +122,5 @@
 static void cursor_setvis(bool visible);
 
+static void key_handle_press(kbd_event_t *ev);
 static void key_handle_unmod(kbd_event_t const *ev);
 static void key_handle_ctrl(kbd_event_t const *ev);
@@ -124,4 +128,6 @@
 static void key_handle_shift_ctrl(kbd_event_t const *ev);
 static void key_handle_movement(unsigned int key, bool shift);
+
+static void pos_handle(pos_event_t *ev);
 
 static int file_save(char const *fname);
@@ -182,5 +188,5 @@
 int main(int argc, char *argv[])
 {
-	kbd_event_t ev;
+	cons_event_t ev;
 	bool new_file;
 	int rc;
@@ -245,24 +251,16 @@
 
 	while (!done) {
-		console_get_kbd_event(con, &ev);
+		console_get_event(con, &ev);
 		pane.rflags = 0;
 
-		if (ev.type == KEY_PRESS) {
-			/* Handle key press. */
-			if (((ev.mods & KM_ALT) == 0) &&
-			    ((ev.mods & KM_SHIFT) == 0) &&
-			     (ev.mods & KM_CTRL) != 0) {
-				key_handle_ctrl(&ev);
-			} else if (((ev.mods & KM_ALT) == 0) &&
-			    ((ev.mods & KM_CTRL) == 0) &&
-			     (ev.mods & KM_SHIFT) != 0) {
-				key_handle_shift(&ev);
-			} else if (((ev.mods & KM_ALT) == 0) &&
-			    ((ev.mods & KM_CTRL) != 0) &&
-			     (ev.mods & KM_SHIFT) != 0) {
-				key_handle_shift_ctrl(&ev);
-			} else if ((ev.mods & (KM_CTRL | KM_ALT | KM_SHIFT)) == 0) {
-				key_handle_unmod(&ev);
-			}
+		switch (ev.type) {
+		case CEV_KEY:
+			pane.keymod = ev.ev.key.mods;
+			if (ev.ev.key.type == KEY_PRESS)
+				key_handle_press(&ev.ev.key);
+			break;
+		case CEV_POS:
+			pos_handle(&ev.ev.pos);
+			break;
 		}
 
@@ -286,4 +284,24 @@
 
 	return 0;
+}
+
+/* Handle key press. */
+static void key_handle_press(kbd_event_t *ev)
+{
+	if (((ev->mods & KM_ALT) == 0) &&
+	    ((ev->mods & KM_SHIFT) == 0) &&
+	     (ev->mods & KM_CTRL) != 0) {
+		key_handle_ctrl(ev);
+	} else if (((ev->mods & KM_ALT) == 0) &&
+	    ((ev->mods & KM_CTRL) == 0) &&
+	     (ev->mods & KM_SHIFT) != 0) {
+		key_handle_shift(ev);
+	} else if (((ev->mods & KM_ALT) == 0) &&
+	    ((ev->mods & KM_CTRL) != 0) &&
+	     (ev->mods & KM_SHIFT) != 0) {
+		key_handle_shift_ctrl(ev);
+	} else if ((ev->mods & (KM_CTRL | KM_ALT | KM_SHIFT)) == 0) {
+		key_handle_unmod(ev);
+	}
 }
 
@@ -462,4 +480,21 @@
 }
 
+static void pos_handle(pos_event_t *ev)
+{
+	coord_t bc;
+	spt_t pt;
+	bool select;
+
+	if (ev->type == POS_PRESS && ev->vpos < (unsigned)pane.rows) {
+		bc.row = pane.sh_row + ev->vpos;
+		bc.column = pane.sh_column + ev->hpos;
+		sheet_get_cell_pt(doc.sh, &bc, dir_before, &pt);
+
+		select = (pane.keymod & KM_SHIFT) != 0;
+
+		caret_move(pt, select, true);
+	}
+}
+
 /** Move caret while preserving or resetting selection. */
 static void caret_move(spt_t new_caret_pt, bool select, bool update_ideal_column)
@@ -592,5 +627,6 @@
 static char *prompt(char const *prompt, char const *init_value)
 {
-	kbd_event_t ev;
+	cons_event_t ev;
+	kbd_event_t *kev;
 	char *str;
 	wchar_t buffer[INFNAME_MAX_LEN + 1];
@@ -612,13 +648,15 @@
 
 	while (!done) {
-		console_get_kbd_event(con, &ev);
-
-		if (ev.type == KEY_PRESS) {
+		console_get_event(con, &ev);
+
+		if (ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS) {
+			kev = &ev.ev.key;
+
 			/* Handle key press. */
-			if (((ev.mods & KM_ALT) == 0) &&
-			     (ev.mods & KM_CTRL) != 0) {
+			if (((kev->mods & KM_ALT) == 0) &&
+			     (kev->mods & KM_CTRL) != 0) {
 				;
-			} else if ((ev.mods & (KM_CTRL | KM_ALT)) == 0) {
-				switch (ev.key) {
+			} else if ((kev->mods & (KM_CTRL | KM_ALT)) == 0) {
+				switch (kev->key) {
 				case KC_ESCAPE:
 					return NULL;
@@ -634,8 +672,8 @@
 					break;
 				default:
-					if (ev.c >= 32 && nc < max_len) {
-						putchar(ev.c);
+					if (kev->c >= 32 && nc < max_len) {
+						putchar(kev->c);
 						console_flush(con);
-						buffer[nc++] = ev.c;
+						buffer[nc++] = kev->c;
 					}
 					break;
Index: uspace/app/mkbd/main.c
===================================================================
--- uspace/app/mkbd/main.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/mkbd/main.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -178,6 +178,6 @@
 
 	while (1) {
-		kbd_event_t ev;
-		bool ok = console_get_kbd_event(con, &ev);
+		cons_event_t ev;
+		bool ok = console_get_event(con, &ev);
 		if (!ok) {
 			printf("Connection with console broken: %s.\n",
@@ -186,5 +186,6 @@
 		}
 
-		if (ev.key == KC_ESCAPE) {
+		if (ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS &&
+		    ev.ev.key.key == KC_ESCAPE) {
 			break;
 		}
Index: uspace/app/msim/arch_helenos/input.c
===================================================================
--- uspace/app/msim/arch_helenos/input.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/msim/arch_helenos/input.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -91,17 +91,17 @@
 bool stdin_poll(char *key)
 {
-	kbd_event_t ev;
+	cons_event_t ev;
 	suseconds_t timeout = 0;
 	errno = EOK;
 	console_flush(input_prompt->console);
-	bool has_input = console_get_kbd_event_timeout(input_prompt->console, &ev, &timeout);
+	bool has_input = console_get_event_timeout(input_prompt->console, &ev, &timeout);
 	if (!has_input) {
 		return false;
 	}
 
-	if (ev.type != KEY_PRESS)
+	if (ev.type != CEV_KEY || ev.ev.key.type != KEY_PRESS)
 		return false;
 
-	*key = ev.c;
+	*key = ev.ev.key.c;
 
 	return true;
Index: uspace/app/nterm/nterm.c
===================================================================
--- uspace/app/nterm/nterm.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/nterm/nterm.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -109,5 +109,5 @@
 int main(int argc, char *argv[])
 {
-	kbd_event_t ev;
+	cons_event_t ev;
 	int rc;
 
@@ -129,7 +129,7 @@
 	done = false;
 	while (!done) {
-		console_get_kbd_event(con, &ev);
-		if (ev.type == KEY_PRESS)
-			key_handle(&ev);
+		console_get_event(con, &ev);
+		if (ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS)
+			key_handle(&ev.ev.key);
 	}
 
Index: uspace/app/ping/ping.c
===================================================================
--- uspace/app/ping/ping.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/ping/ping.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -188,5 +188,5 @@
 {
 	console_ctrl_t *con;
-	kbd_event_t ev;
+	cons_event_t ev;
 
 	con = console_init(stdin, stdout);
@@ -194,11 +194,12 @@
 
 	while (true) {
-		if (!console_get_kbd_event(con, &ev))
+		if (!console_get_event(con, &ev))
 			break;
 
-		if (ev.type == KEY_PRESS && (ev.mods & (KM_ALT | KM_SHIFT)) ==
-		    0 && (ev.mods & KM_CTRL) != 0) {
+		if (ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS &&
+		    (ev.ev.key.mods & (KM_ALT | KM_SHIFT)) ==
+		    0 && (ev.ev.key.mods & KM_CTRL) != 0) {
 			/* Ctrl+key */
-			if (ev.key == KC_Q) {
+			if (ev.ev.key.key == KC_Q) {
 				ping_signal_done();
 				return 0;
Index: uspace/app/taskdump/symtab.c
===================================================================
--- uspace/app/taskdump/symtab.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/taskdump/symtab.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -267,5 +267,5 @@
 			continue;
 
-		if (best_name == NULL || (saddr <= addr && saddr > best_addr)) {
+		if (saddr <= addr && (best_name == NULL || saddr > best_addr)) {
 			best_name = sname;
 			best_addr = saddr;
Index: uspace/app/tester/ipc/starve.c
===================================================================
--- uspace/app/tester/ipc/starve.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/tester/ipc/starve.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -62,9 +62,9 @@
 			break;
 		
-		kbd_event_t ev;
+		cons_event_t ev;
 		suseconds_t timeout = 0;
-		bool has_event = console_get_kbd_event_timeout(console, &ev, &timeout);
-		if (has_event && (ev.type == KEY_PRESS)) {
-			TPRINTF("Key %d pressed, terminating.\n", ev.key);
+		bool has_event = console_get_event_timeout(console, &ev, &timeout);
+		if (has_event && ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS) {
+			TPRINTF("Key %d pressed, terminating.\n", ev.ev.key.key);
 			break;
 		}
Index: uspace/app/tetris/scores.c
===================================================================
--- uspace/app/tetris/scores.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/tetris/scores.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -125,5 +125,6 @@
 	int j;
 	size_t off;
-	kbd_event_t ev;
+	cons_event_t ev;
+	kbd_event_t *kev;
 	
 	clear_screen();
@@ -141,14 +142,16 @@
 	while (1) {
 		console_flush(console);
-		if (!console_get_kbd_event(console, &ev))
+		if (!console_get_event(console, &ev))
 			exit(1);
 		
-		if (ev.type == KEY_RELEASE)
+		if (ev.type != CEV_KEY || ev.ev.key.type == KEY_RELEASE)
 			continue;
 		
-		if (ev.key == KC_ENTER || ev.key == KC_NENTER)
+		kev = &ev.ev.key;
+		
+		if (kev->key == KC_ENTER || kev->key == KC_NENTER)
 			break;
 		
-		if (ev.key == KC_BACKSPACE) {
+		if (kev->key == KC_BACKSPACE) {
 			if (i > 0) {
 				wchar_t uc;
@@ -166,7 +169,7 @@
 				scores[NUMSPOTS - 1].hs_name[off] = '\0';
 			}
-		} else if (ev.c != '\0') {
+		} else if (kev->c != '\0') {
 			if (i < (MAXLOGNAME - 1)) {
-				if (chr_encode(ev.c, scores[NUMSPOTS - 1].hs_name,
+				if (chr_encode(kev->c, scores[NUMSPOTS - 1].hs_name,
 				    &off, STR_BOUNDS(MAXLOGNAME) + 1) == EOK) {
 					++i;
Index: uspace/app/tetris/screen.c
===================================================================
--- uspace/app/tetris/screen.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/tetris/screen.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -344,7 +344,7 @@
 	
 	while (timeout > 0) {
-		kbd_event_t event;
-		
-		if (!console_get_kbd_event_timeout(console, &event, &timeout))
+		cons_event_t event;
+		
+		if (!console_get_event_timeout(console, &event, &timeout))
 			break;
 	}
@@ -376,13 +376,13 @@
 	
 	while (c == 0) {
-		kbd_event_t event;
-		
-		if (!console_get_kbd_event_timeout(console, &event, &timeleft)) {
+		cons_event_t event;
+		
+		if (!console_get_event_timeout(console, &event, &timeleft)) {
 			timeleft = 0;
 			return -1;
 		}
 		
-		if (event.type == KEY_PRESS)
-			c = event.c;
+		if (event.type == CEV_KEY && event.ev.key.type == KEY_PRESS)
+			c = event.ev.key.c;
 	}
 	
@@ -398,11 +398,11 @@
 	
 	while (c == 0) {
-		kbd_event_t event;
-		
-		if (!console_get_kbd_event(console, &event))
+		cons_event_t event;
+		
+		if (!console_get_event(console, &event))
 			return -1;
 		
-		if (event.type == KEY_PRESS)
-			c = event.c;
+		if (event.type == CEV_KEY && event.ev.key.type == KEY_PRESS)
+			c = event.ev.key.c;
 	}
 	
Index: uspace/app/top/screen.c
===================================================================
--- uspace/app/top/screen.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/top/screen.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -556,8 +556,8 @@
 	
 	while (c == 0) {
-		kbd_event_t event;
+		cons_event_t event;
 		
 		warning_timeleft -= timeleft;
-		if (!console_get_kbd_event_timeout(console, &event, &timeleft)) {
+		if (!console_get_event_timeout(console, &event, &timeleft)) {
 			timeleft = 0;
 			return -1;
@@ -565,6 +565,6 @@
 		warning_timeleft += timeleft;
 		
-		if (event.type == KEY_PRESS)
-			c = event.c;
+		if (event.type == CEV_KEY && event.ev.key.type == KEY_PRESS)
+			c = event.ev.key.c;
 	}
 	
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/trace/trace.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -565,4 +565,6 @@
 static int cev_fibril(void *arg)
 {
+	cons_event_t event;
+
 	(void) arg;
 	
@@ -575,11 +577,14 @@
 		fibril_mutex_unlock(&state_lock);
 		
-		if (!console_get_kbd_event(console, &cev))
+		if (!console_get_event(console, &event))
 			return -1;
 		
-		fibril_mutex_lock(&state_lock);
-		cev_valid = true;
-		fibril_condvar_broadcast(&state_cv);
-		fibril_mutex_unlock(&state_lock);
+		if (event.type == CEV_KEY) {
+			fibril_mutex_lock(&state_lock);
+			cev = event.ev.key;
+			cev_valid = true;
+			fibril_condvar_broadcast(&state_cv);
+			fibril_mutex_unlock(&state_lock);
+		}
 	}
 }
Index: uspace/app/vdemo/vdemo.c
===================================================================
--- uspace/app/vdemo/vdemo.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/vdemo/vdemo.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -141,8 +141,8 @@
 		    lbl_action->cancel);
 
-		grid->add(grid, &lbl_action->label.widget, 0, 0, 1, 2);
-		grid->add(grid, &btn_confirm->widget, 1, 0, 1, 1);
+		grid->add(grid, &lbl_action->label.widget, 0, 0, 2, 1);
+		grid->add(grid, &btn_confirm->widget, 0, 1, 1, 1);
 		grid->add(grid, &btn_cancel->widget, 1, 1, 1, 1);
-		window_resize(main_window, 200, 70);
+		window_resize(main_window, 200, 76);
 
 		window_exec(main_window);
Index: uspace/app/vlaunch/Makefile
===================================================================
--- uspace/app/vlaunch/Makefile	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/vlaunch/Makefile	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -35,5 +35,15 @@
 
 SOURCES = \
-	vlaunch.c
+	vlaunch.c \
+	images.c
+
+IMAGES = \
+	gfx/helenos.tga
+
+PRE_DEPEND = images.c images.h
+EXTRA_CLEAN = images.c images.h
 
 include $(USPACE_PREFIX)/Makefile.common
+
+images.c images.h: $(IMAGES)
+	$(ROOT_PATH)/tools/mkarray.py images COMPOSITOR_IMAGES $^
Index: uspace/app/vlaunch/vlaunch.c
===================================================================
--- uspace/app/vlaunch/vlaunch.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/app/vlaunch/vlaunch.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -46,6 +46,17 @@
 #include <button.h>
 #include <label.h>
+#include <canvas.h>
 
-#define NAME "vlaunch"
+#include <surface.h>
+#include <source.h>
+#include <drawctx.h>
+#include <codec/tga.h>
+
+#include "images.h"
+
+#define NAME  "vlaunch"
+
+#define LOGO_WIDTH   196
+#define LOGO_HEIGHT  66
 
 static char *winreg = NULL;
@@ -97,4 +108,10 @@
 	}
 	
+	surface_t *logo = decode_tga((void *) helenos_tga, helenos_tga_size, 0);
+	if (!logo) {
+		printf("Unable to decode logo.\n");
+		return 1;
+	}
+	
 	winreg = argv[1];
 	window_t *main_window = window_open(argv[1], true, true, "vlaunch", 0, 0);
@@ -104,10 +121,12 @@
 	}
 	
-	pixel_t grd_bg = PIXEL(255, 240, 240, 240);
+	pixel_t grd_bg = PIXEL(255, 255, 255, 255);
 	pixel_t btn_bg = PIXEL(255, 0, 0, 0);
 	pixel_t btn_fg = PIXEL(255, 240, 240, 240);
-	pixel_t lbl_bg = PIXEL(255, 240, 240, 240);
+	pixel_t lbl_bg = PIXEL(255, 255, 255, 255);
 	pixel_t lbl_fg = PIXEL(255, 0, 0, 0);
 	
+	canvas_t *logo_canvas = create_canvas(NULL, LOGO_WIDTH, LOGO_HEIGHT,
+	    logo);
 	label_t *lbl_caption = create_label(NULL, "Launch application:", 16,
 	    lbl_bg, lbl_fg);
@@ -118,8 +137,8 @@
 	button_t *btn_vlaunch = create_button(NULL, "vlaunch", 16, btn_bg,
 	    btn_fg);
-	grid_t *grid = create_grid(window_root(main_window), 4, 1, grd_bg);
+	grid_t *grid = create_grid(window_root(main_window), 1, 5, grd_bg);
 	
-	if ((!lbl_caption) || (!btn_vterm) || (!btn_vdemo) ||
-	    (!btn_vlaunch) || (!grid)) {
+	if ((!logo_canvas) || (!lbl_caption) || (!btn_vterm) ||
+	    (!btn_vdemo) || (!btn_vlaunch) || (!grid)) {
 		window_close(main_window);
 		printf("Cannot create widgets.\n");
@@ -131,11 +150,13 @@
 	sig_connect(&btn_vlaunch->clicked, NULL, on_vlaunch);
 	
-	grid->add(grid, &lbl_caption->widget, 0, 0, 1, 1);
-	grid->add(grid, &btn_vterm->widget, 1, 0, 1, 1);
-	grid->add(grid, &btn_vdemo->widget, 2, 0, 1, 1);
-	grid->add(grid, &btn_vlaunch->widget, 3, 0, 1, 1);
+	grid->add(grid, &logo_canvas->widget, 0, 0, 1, 1);
+	grid->add(grid, &lbl_caption->widget, 0, 1, 1, 1);
+	grid->add(grid, &btn_vterm->widget, 0, 2, 1, 1);
+	grid->add(grid, &btn_vdemo->widget, 0, 3, 1, 1);
+	grid->add(grid, &btn_vlaunch->widget, 0, 4, 1, 1);
 	
-	window_resize(main_window, 180, 130);
+	window_resize(main_window, 210, 130 + LOGO_HEIGHT);
 	window_exec(main_window);
+	
 	task_retval(0);
 	async_manager();
Index: uspace/drv/char/ns8250/ns8250.c
===================================================================
--- uspace/drv/char/ns8250/ns8250.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/drv/char/ns8250/ns8250.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -160,5 +160,5 @@
 	/** I/O registers **/
 	ns8250_regs_t *regs;
-	/** Is there any client conntected to the device? */
+	/** Is there any client connected to the device? */
 	bool client_connected;
 	/** The irq assigned to this device. */
@@ -168,5 +168,5 @@
 	/** The i/o port used to access the serial ports registers. */
 	ioport8_t *port;
-	/** The buffer for incomming data. */
+	/** The buffer for incoming data. */
 	cyclic_buffer_t input_buffer;
 	/** The fibril mutex for synchronizing the access to the device. */
@@ -190,5 +190,5 @@
 }
 
-/** Find out if there is some incomming data available on the serial port.
+/** Find out if there is some incoming data available on the serial port.
  *
  * @param port		The base address of the serial port device's ports.
Index: uspace/lib/c/generic/io/con_srv.c
===================================================================
--- uspace/lib/c/generic/io/con_srv.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/lib/c/generic/io/con_srv.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -35,4 +35,5 @@
  */
 #include <errno.h>
+#include <io/cons_event.h>
 #include <ipc/console.h>
 #include <stdlib.h>
@@ -40,4 +41,28 @@
 
 #include <io/con_srv.h>
+
+static int console_ev_encode(cons_event_t *event, ipc_call_t *call)
+{
+	IPC_SET_ARG1(*call, event->type);
+
+	switch (event->type) {
+	case CEV_KEY:
+		IPC_SET_ARG2(*call, event->ev.key.type);
+		IPC_SET_ARG3(*call, event->ev.key.key);
+		IPC_SET_ARG4(*call, event->ev.key.mods);
+		IPC_SET_ARG5(*call, event->ev.key.c);
+		break;
+	case CEV_POS:
+		IPC_SET_ARG2(*call, (event->ev.pos.pos_id << 16) | (event->ev.pos.type & 0xffff));
+		IPC_SET_ARG3(*call, event->ev.pos.btn_num);
+		IPC_SET_ARG4(*call, event->ev.pos.hpos);
+		IPC_SET_ARG5(*call, event->ev.pos.vpos);
+		break;
+	default:
+		return EIO;
+	}
+
+	return EOK;
+}
 
 static void con_read_srv(con_srv_t *srv, ipc_callid_t callid,
@@ -273,5 +298,6 @@
 {
 	int rc;
-	kbd_event_t event;
+	cons_event_t event;
+	ipc_call_t result;
 
 	if (srv->srvs->ops->get_event == NULL) {
@@ -281,5 +307,17 @@
 
 	rc = srv->srvs->ops->get_event(srv, &event);
-	async_answer_4(callid, rc, event.type, event.key, event.mods, event.c);
+	if (rc != EOK) {
+		async_answer_0(callid, rc);
+		return;
+	}
+
+	rc = console_ev_encode(&event, &result);
+	if (rc != EOK) {
+		async_answer_0(callid, rc);
+		return;
+	}
+
+	async_answer_5(callid, rc, IPC_GET_ARG1(result), IPC_GET_ARG2(result),
+	    IPC_GET_ARG3(result), IPC_GET_ARG4(result), IPC_GET_ARG5(result));
 }
 
Index: uspace/lib/c/generic/io/console.c
===================================================================
--- uspace/lib/c/generic/io/console.c	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/lib/c/generic/io/console.c	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -154,15 +154,40 @@
 }
 
-bool console_get_kbd_event(console_ctrl_t *ctrl, kbd_event_t *event)
+static int console_ev_decode(ipc_call_t *call, cons_event_t *event)
+{
+	event->type = IPC_GET_ARG1(*call);
+
+	switch (event->type) {
+	case CEV_KEY:
+		event->ev.key.type = IPC_GET_ARG2(*call);
+		event->ev.key.key = IPC_GET_ARG3(*call);
+		event->ev.key.mods = IPC_GET_ARG4(*call);
+		event->ev.key.c = IPC_GET_ARG5(*call);
+		break;
+	case CEV_POS:
+		event->ev.pos.pos_id = IPC_GET_ARG2(*call) >> 16;
+		event->ev.pos.type = IPC_GET_ARG2(*call) & 0xffff;
+		event->ev.pos.btn_num = IPC_GET_ARG3(*call);
+		event->ev.pos.hpos = IPC_GET_ARG4(*call);
+		event->ev.pos.vpos = IPC_GET_ARG5(*call);
+		break;
+	default:
+		return EIO;
+	}
+
+	return EOK;
+}
+
+bool console_get_event(console_ctrl_t *ctrl, cons_event_t *event)
 {
 	if (ctrl->input_aid == 0) {
-		sysarg_t type;
-		sysarg_t key;
-		sysarg_t mods;
-		sysarg_t c;
+		ipc_call_t result;
 		
 		async_exch_t *exch = async_exchange_begin(ctrl->input_sess);
-		int rc = async_req_0_4(exch, CONSOLE_GET_EVENT, &type, &key, &mods, &c);
+		aid_t aid = async_send_0(exch, CONSOLE_GET_EVENT, &result);
 		async_exchange_end(exch);
+		
+		sysarg_t rc;
+		async_wait_for(aid, &rc);
 		
 		if (rc != EOK) {
@@ -171,8 +196,9 @@
 		}
 		
-		event->type = type;
-		event->key = key;
-		event->mods = mods;
-		event->c = c;
+		rc = console_ev_decode(&result, event);
+		if (rc != EOK) {
+			errno = rc;
+			return false;
+		}
 	} else {
 		sysarg_t retval;
@@ -186,8 +212,9 @@
 		}
 		
-		event->type = IPC_GET_ARG1(ctrl->input_call);
-		event->key = IPC_GET_ARG2(ctrl->input_call);
-		event->mods = IPC_GET_ARG3(ctrl->input_call);
-		event->c = IPC_GET_ARG4(ctrl->input_call);
+		int rc = console_ev_decode(&ctrl->input_call, event);
+		if (rc != EOK) {
+			errno = rc;
+			return false;
+		}
 	}
 	
@@ -195,5 +222,5 @@
 }
 
-bool console_get_kbd_event_timeout(console_ctrl_t *ctrl, kbd_event_t *event,
+bool console_get_event_timeout(console_ctrl_t *ctrl, cons_event_t *event,
     suseconds_t *timeout)
 {
@@ -223,8 +250,9 @@
 	}
 	
-	event->type = IPC_GET_ARG1(ctrl->input_call);
-	event->key = IPC_GET_ARG2(ctrl->input_call);
-	event->mods = IPC_GET_ARG3(ctrl->input_call);
-	event->c = IPC_GET_ARG4(ctrl->input_call);
+	rc = console_ev_decode(&ctrl->input_call, event);
+	if (rc != EOK) {
+		errno = rc;
+		return false;
+	}
 	
 	/* Update timeout */
Index: uspace/lib/c/include/io/con_srv.h
===================================================================
--- uspace/lib/c/include/io/con_srv.h	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/lib/c/include/io/con_srv.h	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -41,5 +41,5 @@
 #include <io/color.h>
 #include <io/concaps.h>
-#include <io/kbd_event.h>
+#include <io/cons_event.h>
 #include <io/pixel.h>
 #include <io/style.h>
@@ -82,5 +82,5 @@
 	void (*set_rgb_color)(con_srv_t *, pixel_t, pixel_t);
 	void (*set_cursor_visibility)(con_srv_t *, bool);
-	int (*get_event)(con_srv_t *, kbd_event_t *);
+	int (*get_event)(con_srv_t *, cons_event_t *);
 } con_ops_t;
 
Index: uspace/lib/c/include/io/cons_event.h
===================================================================
--- uspace/lib/c/include/io/cons_event.h	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
+++ uspace/lib/c/include/io/cons_event.h	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -0,0 +1,66 @@
+/*
+ * Copyright (c) 2013 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_IO_CONS_EVENT_H_
+#define LIBC_IO_CONS_EVENT_H_
+
+#include <adt/list.h>
+#include <io/kbd_event.h>
+#include <io/pos_event.h>
+
+typedef enum {
+	/** Key event */
+	CEV_KEY,
+	/** Position event */
+	CEV_POS
+} cons_event_type_t;
+
+/** Console event structure. */
+typedef struct {
+	/** List handle */
+	link_t link;
+
+	/** Event type */
+	cons_event_type_t type;
+
+	union {
+		kbd_event_t key;
+		pos_event_t pos;
+	} ev;
+} cons_event_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/io/console.h
===================================================================
--- uspace/lib/c/include/io/console.h	(revision 06b0211b4ee03a6f5e22a538f727075215620bb6)
+++ uspace/lib/c/include/io/console.h	(revision aa2b32c3f7c33c46ece6059038015e42595a80de)
@@ -39,4 +39,5 @@
 #include <io/concaps.h>
 #include <io/kbd_event.h>
+#include <io/cons_event.h>
 #include <io/keycode.h>
 #include <async.h>
@@ -82,6 +83,6 @@
 extern void console_cursor_visibility(console_ctrl_t *, bool);
 extern int console_get_color_cap(console_ctrl_t *, sysarg_t *);
-extern bool console_get_kbd_event(console_ctrl_t *, kbd_event_t *);
-extern bool console_get_kbd_event_timeout(console_ctrl_t *, kbd_event_t *,
+extern bool console_get_event(console_ctrl_t *, cons_event_t *);
+extern bool console_get_event_timeout(console_ctrl_t *, cons_event_t *,
     suseconds_t *);
 
